﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using MovieCharactersAPI.Data;

#nullable disable

namespace MovieCharactersAPI.Migrations
{
    [DbContext(typeof(MoviesDbContext))]
    [Migration("20230130132317_AddNewSeedMovie")]
    partial class AddNewSeedMovie
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder, 1L, 1);

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.Property<int>("CharacterId")
                        .HasColumnType("int");

                    b.Property<int>("MovieId")
                        .HasColumnType("int");

                    b.HasKey("CharacterId", "MovieId");

                    b.HasIndex("MovieId");

                    b.ToTable("CharacterMovie");

                    b.HasData(
                        new
                        {
                            CharacterId = 1,
                            MovieId = 1
                        },
                        new
                        {
                            CharacterId = 2,
                            MovieId = 2
                        },
                        new
                        {
                            CharacterId = 3,
                            MovieId = 1
                        },
                        new
                        {
                            CharacterId = 1,
                            MovieId = 2
                        });
                });

            modelBuilder.Entity("MovieCharactersAPI.Model.Character", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Alias")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.Property<string>("Gender")
                        .IsRequired()
                        .HasColumnType("varchar(20)");

                    b.Property<string>("Picture")
                        .IsRequired()
                        .HasColumnType("varchar(MAX)");

                    b.HasKey("Id");

                    b.ToTable("Characters");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Alias = "Jedi",
                            FullName = "Luke Skywalker",
                            Gender = "Male",
                            Picture = "https://d.wattpad.com/story_parts/673752130/images/1574ff177d6e82e1726895238013.jpg"
                        },
                        new
                        {
                            Id = 2,
                            Alias = "Sith Lord",
                            FullName = "Darth Vader",
                            Gender = "Male",
                            Picture = "https://th.bing.com/th/id/R.4fc29fd5431a5e58bdd088254ea0d63f?rik=0GIIU8tiHFETng&pid=ImgRaw&r=0"
                        },
                        new
                        {
                            Id = 3,
                            Alias = "Yes",
                            FullName = "Princess Leia",
                            Gender = "Female",
                            Picture = "https://tse3.mm.bing.net/th/id/OIP.jWzu18XPy0MTu8UxuMyhjQHaFe?pid=ImgDet&rs=1"
                        });
                });

            modelBuilder.Entity("MovieCharactersAPI.Model.Franchise", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("varchar(100)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.HasKey("Id");

                    b.ToTable("Franchises");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Description = "All of the star wars movies including spin-off series",
                            Name = "Star wars"
                        },
                        new
                        {
                            Id = 2,
                            Description = "Very nice",
                            Name = "Hollywood"
                        });
                });

            modelBuilder.Entity("MovieCharactersAPI.Model.Movie", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Director")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.Property<int?>("FranchiseId")
                        .HasColumnType("int");

                    b.Property<string>("Genre")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.Property<string>("Picture")
                        .IsRequired()
                        .HasColumnType("varchar(MAX)");

                    b.Property<int>("ReleaseYear")
                        .HasColumnType("int");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasColumnType("varchar(40)");

                    b.Property<string>("Trailer")
                        .IsRequired()
                        .HasColumnType("varchar(MAX)");

                    b.HasKey("Id");

                    b.HasIndex("FranchiseId");

                    b.ToTable("Movies");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Director = "George Lucas",
                            FranchiseId = 1,
                            Genre = "Scfi-Fi, Adventure, Action",
                            Picture = "https://th.bing.com/th/id/R.957d5cb578716e6de70fb2e08e704617?rik=Gcd5Tj2UfHyVBw&riu=http%3a%2f%2fwww.new-video.de%2fco%2fstarwars-epi4.jpg&ehk=ghQODivPT3qDhYUGzpvzy8SPihsBqp1%2bvgQzRVYKDhU%3d&risl=&pid=ImgRaw&r=0",
                            ReleaseYear = 1977,
                            Title = "Star Wars 4",
                            Trailer = "https://www.youtube.com/watch?v=MpkrMqmmy5k"
                        },
                        new
                        {
                            Id = 2,
                            Director = "Steven Spielberg",
                            FranchiseId = 2,
                            Genre = "Action, War",
                            Picture = "https://th.bing.com/th/id/R.7ab4c3d1d606f45f29cfce051c816dbf?rik=gOmrmxLlVeJopg&pid=ImgRaw&r=0",
                            ReleaseYear = 2001,
                            Title = "Saving Private Ryan",
                            Trailer = "https://www.youtube.com/watch?v=zwhP5b4tD6g"
                        },
                        new
                        {
                            Id = 3,
                            Director = "Bjørn Bjørnson",
                            FranchiseId = 2,
                            Genre = "Action, Adventure",
                            Picture = "https://th.bing.com/th/id/R.7ab4c3d1d3606f45f29cfce051c816dbf?rik=gOmrmxLlVeJopg&pid=ImgRaw&r=0",
                            ReleaseYear = 2023,
                            Title = "Monkeyman",
                            Trailer = "https://www.youtube.com/watch?v=zwfhP5b4tD6g"
                        });
                });

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.HasOne("MovieCharactersAPI.Model.Character", null)
                        .WithMany()
                        .HasForeignKey("CharacterId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("MovieCharactersAPI.Model.Movie", null)
                        .WithMany()
                        .HasForeignKey("MovieId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("MovieCharactersAPI.Model.Movie", b =>
                {
                    b.HasOne("MovieCharactersAPI.Model.Franchise", "Franchise")
                        .WithMany("Movies")
                        .HasForeignKey("FranchiseId");

                    b.Navigation("Franchise");
                });

            modelBuilder.Entity("MovieCharactersAPI.Model.Franchise", b =>
                {
                    b.Navigation("Movies");
                });
#pragma warning restore 612, 618
        }
    }
}
